//	{GotLag?}'s Client Scripted Weapons and Defense
//	Code Copyright (c) 2002 Robert "{GotLag?}" McAfee
//
//	http://www.rmca.net	***	gotlag@rmca.net
//
//	If you use this in whole or in part, please give me some credit, just put a comment in your script.

//	Credit: M.I.B. Raven thought of ranged weapons.

// RANGED WEAPONS:
// Weapons will only be available in a chain when they are within range of a target.
// Weapons not known to this script will always be available for use.
// You must keep Weapon Group 1 selected for this script to perform properly.

// MODS:
// The ranged weapons will work with both SentMod and Ragnarok.

// Functions and Usage
// * GLShieldOn() -> Start constant shield rotation
// * GLShieldOff() -> Stop constant shield rotation

// * GLWeaponSlots() -> Required to use this each time you change weapons (before any of them get destroyed)
//			It lets the script know what weapons you have so things work right.

// * GLWeaponOn() -> Start ranged weapons
// * GLWeaponOff() -> Stop ranged weapons

// * GLShieldToggle() -> Use this for making a toggle key.
// * GLWeaponToggle() -> Use this for making a toggle key.

// * GLQuickSetup() -> Focus Shields totally forward, Turn on cloak, Turn on both jammers, target nearest enemy

// --- Key Configuration ---
// You can customize these as needed.

//bind( keyboard, make, shift, W, to, "GLWeaponOn();" );
//bind( keyboard, make, control, W, to, "GLWeaponOff();" );
//bind( keyboard, make, shift, S, to, "GLShieldOn();" );
//bind( keyboard, make, control, S, to, "GLShieldOff();" );

bind( keyboard, make, alt, W, to, "GLWeaponToggle();" );
bind( keyboard, make, alt, S, to, "GLShieldToggle();" );
bind( keyboard, make, shift, W, to, "GLWeaponSlots();" );
bind( keyboard, make, shift, Q, to, "GLQuickSetup();" );

// --- End Key Configuration ---

$GLCW[101] = 750;
$GLCW[102] = 900;
$GLCW[103] = 950;
$GLCW[104] = 900;
$GLCW[105] = 1000;
$GLCW[106] = 150;
$GLCW[107] = 1200;
$GLCW[108] = 1000;
$GLCW[109] = 1000;
$GLCW[110] = 500;
$GLCW[111] = 1000;
$GLCW[112] = 850;
$GLCW[113] = 1000;
$GLCW[114] = 400;
$GLCW[115] = 350;
$GLCW[116] = 650;
$GLCW[117] = 500;
$GLCW[118] = 600;
$GLCW[119] = 1050;
$GLCW[120] = 900;
$GLCW[121] = 1000;
$GLCW[124] = 800;
$GLCW[125] = 800;
$GLCW[126] = 1000;
$GLCW[127] = 1000;
$GLCW[128] = 800;
$GLCW[129] = 1200;
$GLCW[130] = 750;
$GLCW[147] = 3000;
$GLCW[131] = 9999;
$GLCW[132] = 9999;
$GLCW[133] = 9999;
$GLCW[134] = 9999;
$GLCW[135] = 9999;
$GLCW[136] = 9999;
$GLCW[142] = 250;
$GLCW[150] = 500;
$GLCW[3] = 500;
$GLCW[-1] = -100;

if(isObject("sentmodVol"))
{
$GLCW[142] = 1000;
$GLCW[132] = 700;
$GLCW[140] = 950;
$GLCW[148] = 800;
$GLCW[143] = 150;
$GLCW[106] = 250;
$GLCW[135] = 150;
$GLCW[138] = 850;
$GLCW[150] = 2000;
$GLCW[137] = 900;
$GLCW[149] = 850;
$GLCW[131] = 700;
$GLCW[146] = 700;
$GLCW[133] = 1000;
$GLCW[151] = 800;
$GLCW[116] = 1000;
$GLCW[117] = 900;
$GLCW[136] = 800;
$GLCW[118] = 900;
$GLCW[144] = 800;
$GLCW[134] = 1500;
$GLCW[145] = 400;
$GLCW[141] = 600;
$GLCW[139] = 400;
}
else
if(isObject("ragnarokVol"))
{
$GLCW[184] = 1050;
$GLCW[185] = 1200;
$GLCW[177] = 1000;
$GLCW[192] = 150;
$GLCW[193] = 150;
$GLCW[151] = 150;
$GLCW[180] = 50;
$GLCW[179] = 50;
$GLCW[178] = 50;
$GLCW[195] = 1000;
$GLCW[154] = 1100;
$GLCW[123] = 2000;
$GLCW[172] = 500;
$GLCW[117] = 600;
$GLCW[188] = 550;
$GLCW[189] = 500;
$GLCW[153] = 650;
$GLCW[173] = 450;
$GLCW[122] = 1100;
$GLCW[152] = 1000;
$GLCW[191] = 800;
$GLCW[194] = 1000;
}

function ClientVeh() { return GetNextObject("squad",0); }

function GLWeaponRange()
{
	if($GLCW[WEnabled] == 'yes')
	{
		%client = ClientVeh();
		%target = GetTargetId(%client);
		
		if(%target)
		{
			%target.x = getposition(%target,x);
			%target.y = getposition(%target,y);
			%client.x = getposition(%client,x);
			%client.y = getposition(%client,y);

			%range = sqrt(((%target.x-%client.x)*(%target.x-%client.x))+((%target.y-%client.y)*(%target.y-%client.y)));

			for(%i=0;%i<$GLCW[Count];%i++)
			{
				eval("%on=$client::Weapon"@%i@"InGroup0;");
				if(%i == 0) %i = '';
				if(%range <= $GLCWW[%i] || $GLCWW[%i] == 0)
				{
					if(!%on)
					postAction(%client,IDACTION_WEAPON_GROUP_TOGGLE,%i);
				}
				else
				{
					if(%on)
					postAction(%client,IDACTION_WEAPON_GROUP_TOGGLE,%i);
				}
			}
		}
		schedule("GLWeaponRange();",1);
	}
}

function GLShieldRotate()
{
	if($GLCW[SEnabled] == 'yes')
	{
		postAction(ClientVeh(),IDACTION_SHIELD_ROTATION_ADJ,-0.2);
		schedule("GLShieldRotate();",1);
	}
}

function GLQuickSetup()
{
	%client = ClientVeh();
	schedule("postAction("@%client@", IDACTION_SHIELD_FOCUS_ADJ,1);", 1);
	schedule("postAction("@%client@", IDACTION_SHIELD_FOCUS_ADJ,1);", 1.1);
	schedule("postAction("@%client@", IDACTION_SHIELD_FOCUS_ADJ,1);", 1.2);
	schedule("postAction("@%client@", IDACTION_CAMOUFLAGE, 1);", 1.3);
	schedule("postAction("@%client@", IDACTION_ECM_TOGGLE, 1);", 1.3);
	schedule("postAction("@%client@", IDACTION_THERMAL_DIFFUSER_TOGGLE, 1);", 1.3);
	schedule("postAction("@%client@", IDACTION_TARGET_CLOSEST_ENEMY,1);",1.4);
}

function GLWeaponOn() { $GLCW[WEnabled] = 'yes'; GLWeaponRange(); }
function GLWeaponOff() { $GLCW[WEnabled] = 'no'; }
function GLWeaponSlots() { %client = ClientVeh(); $GLCW[Count] = getWeaponCount(%client); $GLCWW[''] = $GLCW[getWeaponId(%client,0)]; for(%i=1;%i<$GLCW[Count];%i++){$GLCWW[%i] = $GLCW[getWeaponId(%client,%i)];} }
function GLShieldOn() { $GLCW[SEnabled] = 'yes'; GLShieldRotate(); }
function GLShieldOff() { $GLCW[SEnabled] = 'no'; }
function GLShieldToggle() { if($GLCW[SEnabled] == 'yes') { GLShieldOff(); } else { GLShieldOn(); } }
function GLWeaponToggle() { if($GLCW[WEnabled] == 'yes') { GLWeaponOff(); } else { GLWeaponOn(); } }